From c4b8128223c0d27ec8af32bd00cc860cf233d9c0 Mon Sep 17 00:00:00 2001
From: Ralph Bean <rbean@redhat.com>
Date: Jul 07 2015 15:57:28 +0000
Subject: [PATCH 145/1001] Add a link to each widget to pop it out and view it individually.


---

diff --git a/hubs/widgets/base.py b/hubs/widgets/base.py
index 4550448..995125c 100644
--- a/hubs/widgets/base.py
+++ b/hubs/widgets/base.py
@@ -42,9 +42,11 @@ def argument(name, default, validator, help):
 def AGPLv3(name):
     def decorator(func):
         @wraps(func)
-        def inner(*args, **kwargs):
-            result = func(*args, **kwargs)
+        def inner(session, widget, *args, **kwargs):
+            result = func(session, widget, *args, **kwargs)
             result['source_url'] = flask.url_for('widget_source', name=name)
+            result['widget_url'] = flask.url_for(
+                'widget_render', hub=widget.hub.name, idx=widget.idx)
             return result
 
         return inner
diff --git a/hubs/widgets/chrome.py b/hubs/widgets/chrome.py
index de38df1..6a313aa 100644
--- a/hubs/widgets/chrome.py
+++ b/hubs/widgets/chrome.py
@@ -8,6 +8,7 @@ _panel_template = jinja2.Template("""
   <div class="pull-right widget-buttons">
     <!-- the AGPLv3 wrapper puts the source url in all responses -->
     <a href="{{source_url}}"><span class="glyphicon glyphicon-eye-open"></span></a>
+    <a href="{{widget_url}}"><span class="glyphicon glyphicon-new-window"></span></a>
     <a href="#"><span class="glyphicon glyphicon-edit"></span></a>
   </div>
   <div class="panel-body">

